#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# basic test of timers

import fwk
from time import sleep


delay = 0.2

print('-'*79)
print("Timer - a simple Timer")
print('-'*79)

timer = fwk.Timer()
timer.start()
for i in range(3):
    sleep(delay)
    print(timer)
timer.stop()
sleep(delay)
print(timer)

print('-'*79)
print("Times - a cpu time (usr, real, kernel)")
print('-'*79)

times = timer.read()
print("it lasted %f secs" % times.getReal().sec())
print("CPU time = %f secs" % times.getUser().sec())

print("once again...")
#print "it lasted %f secs" % timer.read().getReal().sec()  # plante car retour de read() desalloue lors de sec().
#print "CPU time = %f secs" % timer.read().getUser().sec()


print('-'*79)
print("HMSTime - conversion from sec to HMS")
print('-'*79)

nsec = 100000
print("%s secs equals to %s" % (nsec, fwk.HMSTime(nsec)))

print('-'*79)
print("Timers - list of Timers")
print('-'*79)

timers = fwk.Timers()
timers['cpu1'].start()
sleep(delay)
timers['cpu2'].start()
sleep(delay)
timers['cpu3'].start()
sleep(delay)
print(timers)

